/*
 * sequence_reader_test.cpp
 *
 *  Created on: 2010/09/17
 *      Author: shu
 */

#include <gtest/gtest.h>
#include <stdint.h>
#include <iostream>
#include "../src/sequence_reader.h"
#include "../src/sequence.h"

using namespace std;

TEST(SequenceReader, Read) {
  SequenceReaderPtr sequence_reader = CreateSequenceReader("test_protein.fa", FASTA);
  SequencePtr seq;

  seq = sequence_reader->Read();
  EXPECT_EQ("test0", seq->GetName());
  EXPECT_EQ("SESEWWAKKPILQNFMKGAYCPLND",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test1", seq->GetName());
  EXPECT_EQ("TLFVTTSNMFMIQSMATNQLGLRPL",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test2", seq->GetName());
  EXPECT_EQ("MKTPQALSQLDRWEQLLESQYSFMF",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test3", seq->GetName());
  EXPECT_EQ("CVDQPQIQRCNFEWYHRMQVWGRCD",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test4", seq->GetName());
  EXPECT_EQ("ENLVSSSEYRADNWWYVLWIIQLFD",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test5", seq->GetName());
  EXPECT_EQ("AAAAAAAAAAAAAAAAAAAAAAAAA",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test6", seq->GetName());
  EXPECT_EQ("AAAAAAAAAAAAAAAMKGAYCPLND",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_EQ("test7", seq->GetName());
  EXPECT_EQ("ENLVSSSEYRADNYVLWIIQLFD",seq->GetSequenceData());
  seq = sequence_reader->Read();
  EXPECT_FALSE(seq);
}
